#include <stdlib.h>
#include <iostream.h>
#include <Instrument.h>
#include <ugens.h>
#include <Ougens.h>
#include "SYNC.h"
#include <rt.h>

SYNC::SYNC() : Instrument()
{
}

int SYNC::init(float p[], int n_args)
{
	// p0 = start, p[1] = duration, p[2] = pitch (sync freq), p[3] = amp;
	// p[4] = oscil frequency lo, p[5] = oscil frequency hi

	nsamps = rtsetoutput(p[0], p[1], this);

	reset_samps = (1.0/p[2]) * SR; 		// this is the pitch we hear
	sample_count = 0;

	theOscil = new Ooscili(p[4], 1); 	// makegen 1 is the waveform
	theSync = new Ooscili(1.0/p[1], 2); 	// makegen 2 is the oscil reset
						// tracking function
	oscfreqlo = p[4];
	oscfreqhi = p[5];

	amp = p[3];

	return(nsamps);
}

int SYNC::run()
{
	int i;
	float out[2];
	float freq;
	
	Instrument::run();


	for (i = 0; i < chunksamps; i++) {
		out[0] = theOscil->next() * amp;
		out[1] = out[0];

		rtaddout(out);

		sample_count++;
		// when sample_count reachs the reset point, we reset both
		// the phase and the frequency of theOscil
		if (sample_count > reset_samps)
		{
			// note the use of ->next(cursamp) -- this is because
			// we don't increment theSync for every sample
			freq = (theSync->next(cursamp)*(oscfreqhi-oscfreqlo)) + oscfreqlo;
			theOscil->setfreq(freq);
			theOscil->setphase(0.0);
			sample_count = 0;
		}

		cursamp++;
	}
	return i;
}

Instrument*
makeSYNC()
{
	SYNC *inst;
	inst = new SYNC();
	inst->set_bus_config("SYNC");
	return inst;
}

void
rtprofile()
{
	RT_INTRO("SYNC",makeSYNC);
}

